﻿Public Class frmMain

#Region " Event Handlers "
  Private Sub frmMain_Load(ByVal sender As Object, ByVal e As EventArgs) _
      Handles MyBase.Load
    'Set title
    Me.Text = My.Application.Info.AssemblyName & " " & My.Application.Info.Version.ToString(3)

    'Reset the controls
    txtFile.Text = String.Empty
    btnFix.Enabled = False
    btnValidate.Enabled = False

    'Bring myself to the front
    Me.Activate()
  End Sub

  Private Sub txtLine_TextChanged(ByVal sender As Object, ByVal e As EventArgs) _
      Handles txtLine.TextChanged
    Try
      lblChecksumValue.Text = CalculateChecksum(txtLine.Text).ToString("X2")
    Catch ex As Exception
      lblChecksumValue.Text = "NA"
    End Try
  End Sub

  Private Sub txtFile_TextChanged(ByVal sender As Object, ByVal e As EventArgs) _
      Handles txtFile.TextChanged
    If txtFile.Text.Length > 0 Then
      btnValidate.Enabled = True
      btnFix.Enabled = True
    Else
      btnValidate.Enabled = False
      btnFix.Enabled = False
    End If
  End Sub

  Private Sub btnBrowse_Click(ByVal sender As Object, ByVal e As EventArgs) _
      Handles btnBrowse.Click
    Try
      Dim ofd As New System.Windows.Forms.OpenFileDialog()

      'Disable the form until we're done
      Me.Enabled = False

      ofd.AddExtension = True
      ofd.CheckFileExists = True
      ofd.CheckPathExists = True
      ofd.DefaultExt = "hex"
      ofd.Filter = "Intel Hex Files (*.hex)|*.hex|All Files (*.*)|*.*"
      ofd.Multiselect = False
      ofd.Title = "Select Intel Hex File to Fix"

      If ofd.ShowDialog() = Windows.Forms.DialogResult.OK Then
        txtFile.Text = ofd.FileName
      End If
    Catch
      Throw
    Finally
      'Enable the form, we're done
      Me.Enabled = True
    End Try
  End Sub

  Private Sub btnFix_Click(ByVal sender As Object, ByVal e As EventArgs) _
      Handles btnFix.Click
    Try
      Dim sfd As New System.Windows.Forms.SaveFileDialog()

      'Disable the form until we're done
      Me.Enabled = False

      sfd.AddExtension = True
      sfd.Filter = "Intel Hex Files (*.hex)|*.hex|All Files (*.*)|*.*"
      sfd.Title = "Save Fixed File"

      If sfd.ShowDialog() = Windows.Forms.DialogResult.OK Then
        FixIntelHexFile(txtFile.Text, sfd.FileName)

        System.Windows.Forms.MessageBox.Show("The file was written successfully!", "Success", _
            Windows.Forms.MessageBoxButtons.OK, Windows.Forms.MessageBoxIcon.Information)
      End If
    Catch ex As Exception
      System.Windows.Forms.MessageBox.Show("The file was NOT fixed successfully. The error is below:" & _
            Environment.NewLine & Environment.NewLine & ex.ToString(), "Failure", _
            Windows.Forms.MessageBoxButtons.OK, Windows.Forms.MessageBoxIcon.Error)
    Finally
      'Re-enable the form, we're done
      Me.Enabled = True
    End Try
  End Sub

  Private Sub btnValidate_Click(ByVal sender As Object, ByVal e As EventArgs) _
        Handles btnValidate.Click
    Try
      'Disable the form until we're done
      Me.Enabled = False

      If Not ValidateIntelHexFile(txtFile.Text) Then
        System.Windows.Forms.MessageBox.Show("The file does NOT appear to be valid!", "Validation Failed", _
            Windows.Forms.MessageBoxButtons.OK, Windows.Forms.MessageBoxIcon.Exclamation)
      Else
        System.Windows.Forms.MessageBox.Show("The file appears to be valid!", "Validation Succeeded", _
            Windows.Forms.MessageBoxButtons.OK, Windows.Forms.MessageBoxIcon.Information)
      End If
    Catch ex As Exception
      System.Windows.Forms.MessageBox.Show("The file could not be read. The error is below:" & _
            Environment.NewLine & Environment.NewLine & ex.ToString(), "Failure", _
            Windows.Forms.MessageBoxButtons.OK, Windows.Forms.MessageBoxIcon.Error)
    Finally
      'Re-enable the form, we're done
      Me.Enabled = True
    End Try
  End Sub
#End Region

End Class
